Index: uspace/lib/ui/include/ui/menudd.h
===================================================================
--- uspace/lib/ui/include/ui/menudd.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/ui/menudd.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,68 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Menu drop-down
+ */
+
+#ifndef _UI_MENUDD_H
+#define _UI_MENUDD_H
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <io/kbd_event.h>
+#include <io/pos_event.h>
+#include <stdbool.h>
+#include <types/common.h>
+#include <types/ui/menu.h>
+#include <types/ui/menudd.h>
+#include <types/ui/menubar.h>
+#include <types/ui/event.h>
+#include <uchar.h>
+
+extern errno_t ui_menu_dd_create(ui_menu_bar_t *, const char *, ui_menu_dd_t **,
+    ui_menu_t **);
+extern void ui_menu_dd_destroy(ui_menu_dd_t *);
+extern ui_menu_dd_t *ui_menu_dd_first(ui_menu_bar_t *);
+extern ui_menu_dd_t *ui_menu_dd_next(ui_menu_dd_t *);
+extern ui_menu_dd_t *ui_menu_dd_last(ui_menu_bar_t *);
+extern ui_menu_dd_t *ui_menu_dd_prev(ui_menu_dd_t *);
+extern const char *ui_menu_dd_caption(ui_menu_dd_t *);
+extern void ui_menu_dd_get_rect(ui_menu_dd_t *, gfx_coord2_t *, gfx_rect_t *);
+extern char32_t ui_menu_dd_get_accel(ui_menu_dd_t *);
+extern errno_t ui_menu_dd_open(ui_menu_dd_t *, gfx_rect_t *, sysarg_t);
+extern void ui_menu_dd_close(ui_menu_dd_t *);
+extern bool ui_menu_dd_is_open(ui_menu_dd_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/menuentry.h
===================================================================
--- uspace/lib/ui/include/ui/menuentry.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/menuentry.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,4 +39,6 @@
 #include <errno.h>
 #include <gfx/coord.h>
+#include <io/pos_event.h>
+#include <stdbool.h>
 #include <types/ui/menu.h>
 #include <types/ui/menuentry.h>
@@ -49,6 +51,10 @@
 extern void ui_menu_entry_set_cb(ui_menu_entry_t *, ui_menu_entry_cb_t,
     void *);
+extern void ui_menu_entry_set_disabled(ui_menu_entry_t *, bool);
+extern bool ui_menu_entry_is_disabled(ui_menu_entry_t *);
 extern ui_menu_entry_t *ui_menu_entry_first(ui_menu_t *);
+extern ui_menu_entry_t *ui_menu_entry_last(ui_menu_t *);
 extern ui_menu_entry_t *ui_menu_entry_next(ui_menu_entry_t *);
+extern ui_menu_entry_t *ui_menu_entry_prev(ui_menu_entry_t *);
 extern gfx_coord_t ui_menu_entry_calc_width(ui_menu_t *,
     gfx_coord_t, gfx_coord_t);
@@ -56,9 +62,12 @@
     gfx_coord_t *, gfx_coord_t *);
 extern gfx_coord_t ui_menu_entry_height(ui_menu_entry_t *);
+extern char32_t ui_menu_entry_get_accel(ui_menu_entry_t *);
 extern errno_t ui_menu_entry_paint(ui_menu_entry_t *, gfx_coord2_t *);
+extern bool ui_menu_entry_selectable(ui_menu_entry_t *);
 extern void ui_menu_entry_press(ui_menu_entry_t *, gfx_coord2_t *);
 extern void ui_menu_entry_release(ui_menu_entry_t *);
 extern void ui_menu_entry_enter(ui_menu_entry_t *, gfx_coord2_t *);
 extern void ui_menu_entry_leave(ui_menu_entry_t *, gfx_coord2_t *);
+extern void ui_menu_entry_activate(ui_menu_entry_t *);
 extern ui_evclaim_t ui_menu_entry_pos_event(ui_menu_entry_t *, gfx_coord2_t *,
     pos_event_t *);
Index: uspace/lib/ui/include/ui/paint.h
===================================================================
--- uspace/lib/ui/include/ui/paint.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/paint.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -55,8 +55,31 @@
 extern errno_t ui_paint_filled_circle(gfx_context_t *, gfx_coord2_t *,
     gfx_coord_t, ui_fcircle_part_t);
+extern errno_t ui_paint_up_triangle(gfx_context_t *, gfx_coord2_t *,
+    gfx_coord_t);
+extern errno_t ui_paint_down_triangle(gfx_context_t *, gfx_coord2_t *,
+    gfx_coord_t);
+extern errno_t ui_paint_left_triangle(gfx_context_t *, gfx_coord2_t *,
+    gfx_coord_t);
+extern errno_t ui_paint_right_triangle(gfx_context_t *, gfx_coord2_t *,
+    gfx_coord_t);
+extern errno_t ui_paint_cross(gfx_context_t *, gfx_coord2_t *, gfx_coord_t,
+    gfx_coord_t, gfx_coord_t);
+extern errno_t ui_paint_minicon(ui_resource_t *, gfx_coord2_t *, gfx_coord_t,
+    gfx_coord_t);
+extern errno_t ui_paint_maxicon(ui_resource_t *, gfx_coord2_t *, gfx_coord_t,
+    gfx_coord_t);
+extern errno_t ui_paint_unmaxicon(ui_resource_t *, gfx_coord2_t *, gfx_coord_t,
+    gfx_coord_t, gfx_coord_t, gfx_coord_t);
+extern errno_t ui_paint_text_box_custom(ui_resource_t *, gfx_rect_t *,
+    ui_box_chars_t *, gfx_color_t *);
 extern errno_t ui_paint_text_box(ui_resource_t *, gfx_rect_t *,
     ui_box_style_t, gfx_color_t *);
 extern errno_t ui_paint_text_hbrace(ui_resource_t *, gfx_rect_t *,
     ui_box_style_t, gfx_color_t *);
+extern errno_t ui_paint_text_rect(ui_resource_t *, gfx_rect_t *, gfx_color_t *,
+    const char *);
+extern void ui_text_fmt_init(ui_text_fmt_t *);
+extern gfx_coord_t ui_text_width(gfx_font_t *, const char *);
+extern errno_t ui_paint_text(gfx_coord2_t *, ui_text_fmt_t *, const char *);
 
 #endif
Index: uspace/lib/ui/include/ui/pbutton.h
===================================================================
--- uspace/lib/ui/include/ui/pbutton.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/pbutton.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -51,6 +51,12 @@
 extern ui_control_t *ui_pbutton_ctl(ui_pbutton_t *);
 extern void ui_pbutton_set_cb(ui_pbutton_t *, ui_pbutton_cb_t *, void *);
+extern void ui_pbutton_set_decor_ops(ui_pbutton_t *, ui_pbutton_decor_ops_t *,
+    void *);
+extern void ui_pbutton_set_flags(ui_pbutton_t *, ui_pbutton_flags_t);
 extern void ui_pbutton_set_rect(ui_pbutton_t *, gfx_rect_t *);
 extern void ui_pbutton_set_default(ui_pbutton_t *, bool);
+extern bool ui_pbutton_get_light(ui_pbutton_t *);
+extern void ui_pbutton_set_light(ui_pbutton_t *, bool);
+extern errno_t ui_pbutton_set_caption(ui_pbutton_t *, const char *);
 extern errno_t ui_pbutton_paint(ui_pbutton_t *);
 extern void ui_pbutton_press(ui_pbutton_t *);
@@ -59,4 +65,6 @@
 extern void ui_pbutton_leave(ui_pbutton_t *);
 extern void ui_pbutton_clicked(ui_pbutton_t *);
+extern void ui_pbutton_down(ui_pbutton_t *);
+extern void ui_pbutton_up(ui_pbutton_t *);
 extern ui_evclaim_t ui_pbutton_pos_event(ui_pbutton_t *, pos_event_t *);
 
Index: uspace/lib/ui/include/ui/popup.h
===================================================================
--- uspace/lib/ui/include/ui/popup.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/popup.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -54,4 +54,5 @@
 extern ui_resource_t *ui_popup_get_res(ui_popup_t *);
 extern gfx_context_t *ui_popup_get_gc(ui_popup_t *);
+extern sysarg_t ui_popup_get_idev_id(ui_popup_t *);
 
 #endif
Index: uspace/lib/ui/include/ui/resource.h
===================================================================
--- uspace/lib/ui/include/ui/resource.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/resource.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -38,4 +38,5 @@
 
 #include <errno.h>
+#include <gfx/color.h>
 #include <gfx/context.h>
 #include <gfx/font.h>
@@ -49,4 +50,7 @@
 extern void ui_resource_expose(ui_resource_t *);
 extern gfx_font_t *ui_resource_get_font(ui_resource_t *);
+extern bool ui_resource_is_textmode(ui_resource_t *);
+extern gfx_color_t *ui_resource_get_wnd_face_color(ui_resource_t *);
+extern gfx_color_t *ui_resource_get_wnd_text_color(ui_resource_t *);
 
 #endif
Index: uspace/lib/ui/include/ui/scrollbar.h
===================================================================
--- uspace/lib/ui/include/ui/scrollbar.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/ui/scrollbar.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,77 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Scrollbar
+ */
+
+#ifndef _UI_SCROLLBAR_H
+#define _UI_SCROLLBAR_H
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <io/pos_event.h>
+#include <stdbool.h>
+#include <types/ui/control.h>
+#include <types/ui/event.h>
+#include <types/ui/scrollbar.h>
+#include <types/ui/ui.h>
+#include <types/ui/window.h>
+
+extern errno_t ui_scrollbar_create(ui_t *, ui_window_t *, ui_scrollbar_dir_t,
+    ui_scrollbar_t **);
+extern void ui_scrollbar_destroy(ui_scrollbar_t *);
+extern ui_control_t *ui_scrollbar_ctl(ui_scrollbar_t *);
+extern void ui_scrollbar_set_cb(ui_scrollbar_t *, ui_scrollbar_cb_t *, void *);
+extern void ui_scrollbar_set_rect(ui_scrollbar_t *, gfx_rect_t *);
+extern errno_t ui_scrollbar_paint(ui_scrollbar_t *);
+extern gfx_coord_t ui_scrollbar_trough_length(ui_scrollbar_t *);
+extern gfx_coord_t ui_scrollbar_move_length(ui_scrollbar_t *);
+extern gfx_coord_t ui_scrollbar_get_pos(ui_scrollbar_t *);
+extern void ui_scrollbar_set_thumb_length(ui_scrollbar_t *, gfx_coord_t);
+extern void ui_scrollbar_set_pos(ui_scrollbar_t *, gfx_coord_t);
+extern void ui_scrollbar_thumb_press(ui_scrollbar_t *, gfx_coord2_t *);
+extern void ui_scrollbar_upper_trough_press(ui_scrollbar_t *);
+extern void ui_scrollbar_lower_trough_press(ui_scrollbar_t *);
+extern void ui_scrollbar_release(ui_scrollbar_t *, gfx_coord2_t *);
+extern void ui_scrollbar_update(ui_scrollbar_t *, gfx_coord2_t *);
+extern void ui_scrollbar_troughs_update(ui_scrollbar_t *, gfx_coord2_t *);
+extern void ui_scrollbar_up(ui_scrollbar_t *);
+extern void ui_scrollbar_down(ui_scrollbar_t *);
+extern void ui_scrollbar_page_up(ui_scrollbar_t *);
+extern void ui_scrollbar_page_down(ui_scrollbar_t *);
+extern void ui_scrollbar_moved(ui_scrollbar_t *, gfx_coord_t);
+extern ui_evclaim_t ui_scrollbar_pos_event(ui_scrollbar_t *, pos_event_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/selectdialog.h
===================================================================
--- uspace/lib/ui/include/ui/selectdialog.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/ui/selectdialog.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,58 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Select dialog
+ */
+
+#ifndef _UI_SELECTDIALOG_H
+#define _UI_SELECTDIALOG_H
+
+#include <errno.h>
+#include <types/ui/list.h>
+#include <types/ui/selectdialog.h>
+#include <types/ui/ui.h>
+
+extern void ui_select_dialog_params_init(ui_select_dialog_params_t *);
+extern errno_t ui_select_dialog_create(ui_t *, ui_select_dialog_params_t *,
+    ui_select_dialog_t **);
+extern void ui_select_dialog_set_cb(ui_select_dialog_t *, ui_select_dialog_cb_t *,
+    void *);
+extern void ui_select_dialog_destroy(ui_select_dialog_t *);
+extern errno_t ui_select_dialog_append(ui_select_dialog_t *,
+    ui_list_entry_attr_t *);
+extern errno_t ui_select_dialog_paint(ui_select_dialog_t *);
+extern ui_list_t *ui_select_dialog_list(ui_select_dialog_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/slider.h
===================================================================
--- uspace/lib/ui/include/ui/slider.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/slider.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -46,6 +46,5 @@
 #include <types/ui/slider.h>
 
-extern errno_t ui_slider_create(ui_resource_t *, const char *,
-    ui_slider_t **);
+extern errno_t ui_slider_create(ui_resource_t *, ui_slider_t **);
 extern void ui_slider_destroy(ui_slider_t *);
 extern ui_control_t *ui_slider_ctl(ui_slider_t *);
Index: uspace/lib/ui/include/ui/tab.h
===================================================================
--- uspace/lib/ui/include/ui/tab.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/ui/tab.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,67 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Tab
+ */
+
+#ifndef _UI_TAB_H
+#define _UI_TAB_H
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <io/kbd_event.h>
+#include <io/pos_event.h>
+#include <stdbool.h>
+#include <types/common.h>
+#include <types/ui/control.h>
+#include <types/ui/tab.h>
+#include <types/ui/tabset.h>
+#include <types/ui/event.h>
+#include <uchar.h>
+
+extern errno_t ui_tab_create(ui_tab_set_t *, const char *, ui_tab_t **);
+extern void ui_tab_destroy(ui_tab_t *);
+extern ui_tab_t *ui_tab_first(ui_tab_set_t *);
+extern ui_tab_t *ui_tab_next(ui_tab_t *);
+extern ui_tab_t *ui_tab_last(ui_tab_set_t *);
+extern ui_tab_t *ui_tab_prev(ui_tab_t *);
+extern bool ui_tab_is_selected(ui_tab_t *);
+extern void ui_tab_add(ui_tab_t *, ui_control_t *);
+extern void ui_tab_remove(ui_tab_t *, ui_control_t *);
+extern errno_t ui_tab_paint(ui_tab_t *);
+extern ui_evclaim_t ui_tab_kbd_event(ui_tab_t *, kbd_event_t *);
+extern ui_evclaim_t ui_tab_pos_event(ui_tab_t *, pos_event_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/tabset.h
===================================================================
--- uspace/lib/ui/include/ui/tabset.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/ui/tabset.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Tab set
+ */
+
+#ifndef _UI_TABSET_H
+#define _UI_TABSET_H
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <io/kbd_event.h>
+#include <io/pos_event.h>
+#include <types/ui/tabset.h>
+#include <types/ui/control.h>
+#include <types/ui/event.h>
+#include <types/ui/resource.h>
+
+extern errno_t ui_tab_set_create(ui_resource_t *, ui_tab_set_t **);
+extern void ui_tab_set_destroy(ui_tab_set_t *);
+extern ui_control_t *ui_tab_set_ctl(ui_tab_set_t *);
+extern void ui_tab_set_set_rect(ui_tab_set_t *, gfx_rect_t *);
+extern errno_t ui_tab_set_paint(ui_tab_set_t *);
+extern ui_evclaim_t ui_tab_set_kbd_event(ui_tab_set_t *, kbd_event_t *);
+extern ui_evclaim_t ui_tab_set_pos_event(ui_tab_set_t *, pos_event_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/testctl.h
===================================================================
--- uspace/lib/ui/include/ui/testctl.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/ui/testctl.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Test control
+ */
+
+#ifndef _UI_TESTCTL_H
+#define _UI_TESTCTL_H
+
+#include <errno.h>
+#include <types/ui/control.h>
+#include <types/ui/testctl.h>
+
+extern errno_t ui_test_ctl_create(ui_tc_resp_t *, ui_test_ctl_t **);
+extern void ui_test_ctl_destroy(ui_test_ctl_t *);
+extern ui_control_t *ui_test_ctl_ctl(ui_test_ctl_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/ui.h
===================================================================
--- uspace/lib/ui/include/ui/ui.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/ui.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,6 +39,8 @@
 #include <display.h>
 #include <errno.h>
+#include <gfx/coord.h>
 #include <io/console.h>
 #include <stdbool.h>
+#include <types/ui/clickmatic.h>
 #include <types/ui/ui.h>
 
@@ -52,4 +54,11 @@
 extern bool ui_is_textmode(ui_t *);
 extern bool ui_is_fullscreen(ui_t *);
+extern errno_t ui_get_rect(ui_t *, gfx_rect_t *);
+extern errno_t ui_suspend(ui_t *);
+extern errno_t ui_resume(ui_t *);
+extern bool ui_is_suspended(ui_t *);
+extern void ui_lock(ui_t *);
+extern void ui_unlock(ui_t *);
+extern ui_clickmatic_t *ui_get_clickmatic(ui_t *);
 
 #endif
Index: uspace/lib/ui/include/ui/wdecor.h
===================================================================
--- uspace/lib/ui/include/ui/wdecor.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/wdecor.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,8 +39,10 @@
 #include <errno.h>
 #include <gfx/coord.h>
+#include <io/kbd_event.h>
 #include <io/pos_event.h>
 #include <stdbool.h>
 #include <types/ui/event.h>
 #include <types/ui/resource.h>
+#include <types/ui/ui.h>
 #include <types/ui/wdecor.h>
 
@@ -51,7 +53,11 @@
 extern void ui_wdecor_set_rect(ui_wdecor_t *, gfx_rect_t *);
 extern void ui_wdecor_set_active(ui_wdecor_t *, bool);
+extern void ui_wdecor_set_maximized(ui_wdecor_t *, bool);
+extern errno_t ui_wdecor_set_caption(ui_wdecor_t *, const char *);
+extern void ui_wdecor_sysmenu_hdl_set_active(ui_wdecor_t *, bool);
 extern errno_t ui_wdecor_paint(ui_wdecor_t *);
+extern ui_evclaim_t ui_wdecor_kbd_event(ui_wdecor_t *, kbd_event_t *);
 extern ui_evclaim_t ui_wdecor_pos_event(ui_wdecor_t *, pos_event_t *);
-extern void ui_wdecor_rect_from_app(ui_wdecor_style_t, gfx_rect_t *,
+extern void ui_wdecor_rect_from_app(ui_t *, ui_wdecor_style_t, gfx_rect_t *,
     gfx_rect_t *);
 extern void ui_wdecor_app_from_rect(ui_wdecor_style_t, gfx_rect_t *,
Index: uspace/lib/ui/include/ui/window.h
===================================================================
--- uspace/lib/ui/include/ui/window.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/window.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -42,4 +42,5 @@
 #include <io/kbd_event.h>
 #include <io/pos_event.h>
+#include <types/common.h>
 #include <types/ui/control.h>
 #include <types/ui/ui.h>
@@ -51,4 +52,5 @@
     ui_window_t **);
 extern void ui_window_set_cb(ui_window_t *, ui_window_cb_t *, void *);
+extern errno_t ui_window_set_caption(ui_window_t *, const char *);
 extern void ui_window_destroy(ui_window_t *);
 extern void ui_window_add(ui_window_t *, ui_control_t *);
@@ -64,8 +66,12 @@
 extern void ui_window_set_ctl_cursor(ui_window_t *, ui_stock_cursor_t);
 extern errno_t ui_window_paint(ui_window_t *);
-extern void ui_window_def_kbd(ui_window_t *, kbd_event_t *);
+extern errno_t ui_window_def_sysmenu(ui_window_t *, sysarg_t);
+extern errno_t ui_window_def_minimize(ui_window_t *);
+extern errno_t ui_window_def_maximize(ui_window_t *);
+extern errno_t ui_window_def_unmaximize(ui_window_t *);
+extern ui_evclaim_t ui_window_def_kbd(ui_window_t *, kbd_event_t *);
 extern errno_t ui_window_def_paint(ui_window_t *);
 extern void ui_window_def_pos(ui_window_t *, pos_event_t *);
-extern void ui_window_def_unfocus(ui_window_t *);
+extern void ui_window_def_unfocus(ui_window_t *, unsigned);
 
 #endif
Index: uspace/lib/ui/meson.build
===================================================================
--- uspace/lib/ui/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2021 Jiri Svoboda
+# Copyright (c) 2023 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,16 +27,21 @@
 #
 
-deps = [ 'gfx', 'gfxfont', 'memgfx', 'display', 'congfx' ]
+deps = [ 'gfx', 'gfxfont', 'memgfx', 'display', 'congfx', 'clipboard' ]
 src = files(
+	'src/accel.c',
 	'src/checkbox.c',
+	'src/clickmatic.c',
 	'src/control.c',
 	'src/dummygc.c',
 	'src/entry.c',
 	'src/filedialog.c',
+	'src/filelist.c',
 	'src/fixed.c',
 	'src/image.c',
 	'src/label.c',
+	'src/list.c',
 	'src/menu.c',
 	'src/menubar.c',
+	'src/menudd.c',
 	'src/menuentry.c',
 	'src/msgdialog.c',
@@ -47,5 +52,10 @@
 	'src/rbutton.c',
 	'src/resource.c',
+	'src/scrollbar.c',
+	'src/selectdialog.c',
 	'src/slider.c',
+	'src/tab.c',
+	'src/tabset.c',
+	'src/testctl.c',
 	'src/ui.c',
 	'src/wdecor.c',
@@ -54,14 +64,19 @@
 
 test_src = files(
+	'test/accel.c',
 	'test/checkbox.c',
+	'test/clickmatic.c',
 	'test/control.c',
 	'test/entry.c',
 	'test/filedialog.c',
+	'test/filelist.c',
 	'test/fixed.c',
 	'test/image.c',
 	'test/label.c',
+	'test/list.c',
 	'test/main.c',
 	'test/menu.c',
 	'test/menubar.c',
+	'test/menudd.c',
 	'test/menuentry.c',
 	'test/msgdialog.c',
@@ -72,5 +87,10 @@
 	'test/rbutton.c',
 	'test/resource.c',
+	'test/scrollbar.c',
+	'test/selectdialog.c',
 	'test/slider.c',
+	'test/tab.c',
+	'test/tabset.c',
+	'test/testctl.c',
 	'test/ui.c',
 	'test/wdecor.c',
